# This task still has quite a few bugs after update to rjtools_v2.12. Aug 2003
# Need to spend some time to debug this...

procedure tcolarit (tabfil, oper1, operat, oper2, outcol)

string	tabfil	=""	{prompt="free format ASCII file"}
string	oper1	=""	{prompt="operand1 (real | other_colnr: prepend #)"}
string	operat	=""	{prompt="operator",
  enum="+|-|*|/|=|ln|log|exp|dexp|sqrt|sin|cos|tan|abs|int|nint|frac|del"}
string	oper2	=""	{prompt="operand2 (real | other_colnr: prepend #)"}
string	outcol	="new"	{prompt="output column to store result (new|1-15)"}
string	delim	=" "	{prompt="column separation character"}
bool	skiperr =yes    {prompt="skip lines causing errors; print message only?"}
string	format	="%8f"	{prompt="number of decimals to print in result"}

# @(#) task tcolarit                  Author: R.A. Jansen -- Nov 23 1996
# @(#)
# @(#) task for simple arithmetic operations on entries in column-orien-
# @(#) ted ASCII tables. Presently,  single operators  +,-,*,/,  as well
# @(#) as  a set of functions are implemented.  Operations either should
# @(#) be of the form:
# @(#)     <new_value> = <operand1><operator><operand2>
# @(#) where operands can be real- or integer valued constants or column
# @(#) entries from the table (columns are represented by a '#' followed
# @(#) by the column number), or of the form:
# @(#)     <new_value> = <operator><operand1>
# @(#) where operator is one of the functions: ln, log, exp, dexp, sqrt,
# @(#) sin, cos, tan, abs, int, nint  or  frac.  For the latter  format,
# @(#) 'oper2'  must be an empty string ("").  Parameter 'outcol' deter-
# @(#) mines whether the result value <new_value> overwrites an existing
# @(#) column, or is written to a new column (at column number (ncol+1))
# @(#) the latter  being  the default.  Two  special funcions,  '='  and 
# @(#) 'del', are defined,  where '=' is used to copy the values  of one
# @(#) column to another  (possibly reformatting them)  or to initialize
# @(#) all elements of a column to a constant,  while  'del'  is used to
# @(#) delete a column from the table.
# @(#) This task supplements task  'ctio.filecalc',  which is restricted
# @(#) to tables with white-space separated columns but may be more con-
# @(#) venient for complicated arithmetic expressions.
# @(#)
# @(#) Calls 'rjtools' task: 'chkimg' and 'ocparse' (old 'cparse')
# @(#)
# @(#) EXAMPLES:
# @(#) Assume we have a table with 5 columns of real numbers:
# @(#) usr> tcolarit test.fil "#1" "+" "#2" new
# @(#) TCOLARIT: table=test.fil  [#6] = [#1] + [#2]      ncols=5
# @(#) usr> tcolarit test.fil "#6" "log" "" new
# @(#) TCOLARIT: table=test.fil  [#7] = log( [#6] )      ncols=6
# @(#) usr> tcolarit test.fil "#7" "-" 1.00 7
# @(#) TCOLARIT: table=test.fil  [#7] = [#7] - 1.      ncols=7
# @(#)
# @(#) BUGS:
# @(#) Currently, due to the use of task 'ocparse' a limit of 15 columns
# @(#) is enforced. Output can be up to 16 columns, if 'outcol = "new"'.
# @(#)
# @(#) Jan 21 1998 -- Added aditional operators 'nint','=' and 'del' and
# @(#)                added parameter 'format'  to format results.  Also
# @(#)                added regular function 'frac'. RAJ.
# @(#) Aug 17 2003 -- Fixed task to work again by calling an old version
# @(#)                of cparse, after a major overhaul of 'rjtools'.RAJ

begin
	string	ctab, cop1, opt, cop2, ocol, sep, fmt, cstr, ostr, cval
	struct	line
	int	nl, nf, nw, nc1, nc2, i, j, iw
	real    pi, oval, val1, val2, rdif
	bool	white, isfnc, goskip

#	Initialize variables...
	ctab  = tabfil
	cop1  = oper1
	opt   = operat
	cop2  = oper2
	ocol  = outcol
	sep   = delim
	fmt   = format
	if ( sep == "" ) sep = " "
	white = no
	if ( sep == " " || sep == "	" ) white = yes
	pi    = 3.141592653589793

#	Check whether input table exist...
	chkimg (ctab, "access", imtype="file", verbose+)
	if (!chkimg.ok) { return }
	ctab = chkimg.impath//chkimg.imroot

#	Count the number of lines in the table...
	iwc (ctab)
	nl = iwc.nlines

#	See how many columns we have (skip any lines preceded by a comment
#	character ('#') and read the number of table columns from the first
#	uncommented line. In a table with columns that are white space de-
#	limited, leading and multiple delimiters tend to not be significant;
#	they do tend to be significant otherwise...
	list = ctab
	while ( fscan(list,line) != EOF ) {
	    cstr = line
	    if ( substr(cstr,1,1) != '#' ) break
	}
	if ( white) {
	   cparse (cstr, delim=sep, lignore+, mignore+, verbose-)
	} else {
	   cparse (cstr, delim=sep, lignore-, mignore-, verbose-)
	}
	nf = cparse.nfields
	if ( nf > 15 ) {
	   print ("WARNING: Table has more than 15 columns; ignoring remaining columns...")
	}

#	Determine the number of the result column...
	if ( ocol == "new") {
	   nw = nf + 1
	   if ( nw > 15 ) nw = 16
	} else {
	   nw = INDEF
	   print (substr(ocol,2,strlen(ocol))) | scan (nw)
	   if ( nw == INDEF ) {
	      error (1, "Invalid 'outcol=\""//ocol//"\"'!")
	   } else if ( nw > (nf+1) ) {
	      error (1, "'outcol'="//str(nw)//" > number of table columns +1!")
	   } else if ( nw > 15 ) {
	      nw = 16
	   }
	}
	ocol = str(nw)

#	See whether operand1 is a symbolic operand denoting a column...
	nc1 = 0
	if ( substr(cop1,1,1) == "#" ) {
	   nc1  = int(substr(cop1,2,strlen(cop1)))
	   if ( nc1 > 15 && nf > 15 ) {
	      error (1, "Task only has access to columns 1--15!")
	   } else if ( nc1 > 15 ) {
	      error (1, "Invalid column number (>15) in 'oper1'!")
	   } else if ( nc1 > nf ) {
	      error (1, "Only "//str(nf)//" table columns, while 'oper1'=\""//cop1//"\"!")
	   }
	   cop1 = "["//cop1//"]"
	} else { val1 = real(cop1) }

#	The 'enum' in the task parameter definition of 'operat' ensures that
#	the operator is correct; see whether it is a function...
	isfnc = no
	if ( opt == "ln"   || opt == "log"  || opt == "exp"  ) isfnc = yes
	if ( opt == "dexp" || opt == "sqrt" || opt == "sin"  ) isfnc = yes
	if ( opt == "cos"  || opt == "tan"  || opt == "abs"  ) isfnc = yes
	if ( opt == "int"  || opt == "nint" || opt == "frac" ) isfnc = yes
	if ( opt == "del" ) isfnc = yes
	if (isfnc && nc1 == 0 ) {
	   error (1, "'oper1' is not a column, while 'operat' is a function!")
	}
	if (isfnc && cop2 != "" ) {
	   error (1, "'oper2' not empty (\"\"), while 'operat' is a function!")
	}

#	See whether operand2 is a symbolic operand denoting a column...
	nc2 = 0
	if ( !isfnc && substr(cop2,1,1) == "#" ) {
	   nc2  = int(substr(cop2,2,strlen(cop2)))
	   if ( nc2 > 15 && nf > 15 ) {
	      error (1, "Task only has access to columns 1--15!")
	   } else if ( nc2 > 15 ) {
	      error (1, "Invalid column number (>15) in 'oper2'!")
	   } else if ( nc2 > nf ) {
	      error (1, "Only "//str(nf)//" table columns, while 'oper2'=\""//cop2//"\"!")
	   }
	   cop2 = "["//cop2//"]"
	} else if ( !isfnc ) { val2 = real(cop2) }

	if ( opt == "=" ) {
	   if ( substr(cop1,2,2)=="#" ) {
	      ocol = substr(cop1,3,strlen(cop1)-1)
	   } else {
	      ocol = substr(cop2,3,strlen(cop2)-1)
	   }
	}
	if ( opt == "del" ) {
	   ocol = substr(cop1,3,strlen(cop1)-1)
	}

#	Remove any possible debris from a previous run...
	if ( access("tclrt.tab") ) delete ("tclrt.tab", yes, verify-)

#	Decode format specification (presuming format of form: "%w.dC")...
	iw = INDEF
	print (substr(fmt,2,strlen(fmt))) | scan (iw)
	if ( iw == INDEF ) {
	   # at most a precission is specified (e.g. "%.4f")...
	   print (substr(fmt,3,strlen(fmt))) | scan (iw)
	   if ( iw == INDEF ) {
	      print ("WARNING: Could not decode 'format'=\""//fmt//"\"! Using \"%8f\" instead.")
	      iw = 8
	      fmt = "%8f"
	   } else {
	      # reserve some space for digits preceding decimal point...
	      iw = iw + 4
	      fmt = "%"//str(iw)//"."//substr(fmt,3,strlen(fmt))
	   }
	}

#	Input appears OK. Opening message...
	if ( isfnc ) {
	   if ( opt == "del" ) {
	      print ("TCOLARIT: table=\""//ctab//"\"  delete( [#"//str(nc1)//"] )	ncol="//str(nf))
	   } else {
	      print ("TCOLARIT: table=\""//ctab//"\"  [#"//ocol//"] = "//opt//"( [#"//str(nc1)//"] )	ncol="//str(nf))
	   }
	} else {
	   if ( opt == "=" ) {
	      print ("TCOLARIT: table=\""//ctab//"\"  "//cop1//" = "//cop2//"	ncol="//str(nf))
	   } else {
	      print ("TCOLARIT: table=\""//ctab//"\"  [#"//ocol//"] = "//cop1//" "//opt//" "//cop2//"	ncol="//str(nf))
	   }
	}

#       Loop over all lines in the table...
	goskip = no
	i      = 0
	list   = ctab
	while ( fscan(list,line) != EOF ) {
	   cstr = line
	   oval = 0.00
	   i    = i + 1

	   # show progress (for long files)...
	   printf("%s", "\r  processing line: "//str(i)//"\r  ")

	   # skip commented lines...
	   if ( substr(cstr,1,1) == "#" ) {
	      print (cstr, >> "tclrt.tab")
	      next
	   }

	   # parse the line into column entries...
	   ocparse (cstr, delim=sep)

	   # check number of fields in the present table line...
	   if ( ocparse.nfields < nf ) {
	      if (skiperr) {
		 print ("\nWARNING: ncol < "//str(nf)//" in line "//str(i)//"! Skipping line...")
		 goskip = yes
	      } else {
		 error (1, "\nncol < "//str(nf)//" in line "//str(i)//"!")
	      }
	   }
	   if ( ocparse.nfields > nf ) {
	      if (skiperr) {
		 print ("\nWARNING: ncol > "//str(nf)//" in line "//str(i)//"! Skipping line...")
		 goskip = yes
	      } else {
		 error (1, "\nncol > "//str(nf)//" in line "//str(i)//"!")
	      }
	   }
	   # comment out lines with inconsistent number of columns...
	   if (goskip) {
	      print ('#'//cstr, >> "tclrt.tab")
	      goskip = no
	      next
	   }

	   # initialize entries...
	   if ( nc1 != 0 ) {
	      if ( nc1 == 1  ) val1 = real(ocparse.field1)
	      if ( nc1 == 2  ) val1 = real(ocparse.field2)
	      if ( nc1 == 3  ) val1 = real(ocparse.field3)
	      if ( nc1 == 4  ) val1 = real(ocparse.field4)
	      if ( nc1 == 5  ) val1 = real(ocparse.field5)
	      if ( nc1 == 6  ) val1 = real(ocparse.field6)
	      if ( nc1 == 7  ) val1 = real(ocparse.field7)
	      if ( nc1 == 8  ) val1 = real(ocparse.field8)
	      if ( nc1 == 9  ) val1 = real(ocparse.field9)
	      if ( nc1 == 10 ) val1 = real(ocparse.field10)
	      if ( nc1 == 11 ) val1 = real(ocparse.field11)
	      if ( nc1 == 12 ) val1 = real(ocparse.field12)
	      if ( nc1 == 13 ) val1 = real(ocparse.field13)
	      if ( nc1 == 14 ) val1 = real(ocparse.field14)
	      if ( nc1 == 15 ) val1 = real(ocparse.field15)
	   }
	   if ( nc2 != 0 ) {
	      if ( nc2 == 1  ) val2 = real(ocparse.field1)
	      if ( nc2 == 2  ) val2 = real(ocparse.field2)
	      if ( nc2 == 3  ) val2 = real(ocparse.field3)
	      if ( nc2 == 4  ) val2 = real(ocparse.field4)
	      if ( nc2 == 5  ) val2 = real(ocparse.field5)
	      if ( nc2 == 6  ) val2 = real(ocparse.field6)
	      if ( nc2 == 7  ) val2 = real(ocparse.field7)
	      if ( nc2 == 8  ) val2 = real(ocparse.field8)
	      if ( nc2 == 9  ) val2 = real(ocparse.field9)
	      if ( nc2 == 10 ) val2 = real(ocparse.field10)
	      if ( nc2 == 11 ) val2 = real(ocparse.field11)
	      if ( nc2 == 12 ) val2 = real(ocparse.field12)
	      if ( nc2 == 13 ) val2 = real(ocparse.field13)
	      if ( nc2 == 14 ) val2 = real(ocparse.field14)
	      if ( nc2 == 15 ) val2 = real(ocparse.field15)
	   }

	   # perform the requested operation...
	   if ( isfnc ) {
	      #rdif = min(abs(val1-pi/2),abs(val1+pi/2))
	      if ( opt == "ln" && val1 > 0.  )  oval = log(val1)
	      if ( opt == "ln" && val1 <= 0. )  oval = INDEF
	      if ( opt == "log" && val1 > 0. )  oval = log10(val1)
	      if ( opt == "log" && val1 <=0. )  oval = INDEF
	      if ( opt == "sqrt" && val1 >=0. ) oval = sqrt(val1)
	      if ( opt == "sqrt" && val1 < 0. ) oval = INDEF
	      #if ( opt == "tan" && rdif > 1.0e-13 ) oval = tan(val1)
	      #if ( opt == "tan" && rdif < 1.0e-13 ) oval = INDEF
	      if ( opt == "tan"  ) oval = tan(val1)
	      if ( opt == "exp"  ) oval = exp(val1)
	      if ( opt == "dexp" ) oval = 10**(val1)
	      if ( opt == "sin"  ) oval = sin(val1)
	      if ( opt == "cos"  ) oval = cos(val1)
	      if ( opt == "asin" ) oval = asin(val1)
	      if ( opt == "abs"  ) oval = abs(val1)
	      if ( opt == "int"  ) oval = int(val1)
	      if ( opt == "nint" ) oval = nint(val1)
	      if ( opt == "del"  ) oval = INDEF
	   } else {
	      if ( opt == "/" && val2 != 0. ) oval = val1 / val2
	      if ( opt == "/" && val2 == 0. ) oval = INDEF
	      if ( opt == "+"  ) oval = val1 + val2
	      if ( opt == "-"  ) oval = val1 - val2
	      if ( opt == "*"  ) oval = val1 * val2
	      if ( opt == "="  ) {
		 if ( substr(cop1,2,2) == "#" ) {
		    oval = val2
		 } else { oval = val1 }
	      }
	   }

	   # new/updated table entrie...
	   cval = ""
	   if ( oval == INDEF ) {
	      if ( opt != "del" ) {
	         for ( j = 1 ; j <= (iw-5) ; j = j + 1 ) { cval = cval//" " }
	         cval = cval//"INDEF"
	      }
	   } else {
	      printf (fmt//"\n", oval) | scan(cval)
	      for ( j = 1 ; j <= (iw-strlen(cval)) ; j = j + 1 ) {
		 cval = " "//cval
	      }
	   }

#	   Re-construct table line including new/updated entry...
	   ostr = ""
	   if ( ocol != "1" ) {
	      ostr = ocparse.field1
	   } else if ( cval != "" ) { ostr = cval }
	   if ( nf > 1 ) {
	      if ( ocol != "2" ) {
		 ostr = ostr//sep//ocparse.field2
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 2 ) {
	      if ( ocol != "3" ) {
		 ostr = ostr//sep//ocparse.field3
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 3 ) {
	      if ( ocol != "4" ) {
		 ostr = ostr//sep//ocparse.field4
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 4 ) {
	      if ( ocol != "5" ) {
		 ostr = ostr//sep//ocparse.field5
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 5 ) {
	      if ( ocol != "6" ) {
		 ostr = ostr//sep//ocparse.field6
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 6 ) {
	      if ( ocol != "7" ) {
		 ostr = ostr//sep//ocparse.field7
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 7 ) {
	      if ( ocol != "8" ) {
		 ostr = ostr//sep//ocparse.field8
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 8 ) {
	      if ( ocol != "9" ) {
		 ostr = ostr//sep//ocparse.field9
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 9 ) {
	      if ( ocol != "10" ) {
		 ostr = ostr//sep//ocparse.field10
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 10 ) {
	      if ( ocol != "11" ) {
		 ostr = ostr//sep//ocparse.field11
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 11 ) {
	      if ( ocol != "12" ) {
		 ostr = ostr//sep//ocparse.field12
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 12 ) {
	      if ( ocol != "13" ) {
		 ostr = ostr//sep//ocparse.field13
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 13 ) {
	      if ( ocol != "14" ) {
		 ostr = ostr//sep//ocparse.field14
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 14 ) {
	      if ( ocol != "15" ) {
		 ostr = ostr//sep//ocparse.field15
	      } else if ( cval != "" ) { ostr = ostr//sep//cval }
	   }
	   if ( nf > 15 ) {
	      if ( ocol == "16" ) {
	         if ( cval != "" ) { ostr = ostr//sep//cval }
	      }
	   }
	   if ( nw == (nf+1) ) {
	      if ( cval != "" ) { ostr = ostr//sep//cval }
	   }

	   # Write out new table line ...
	   print (ostr, >> "tclrt.tab")
	}

#	Delete old table file and rename new table file...
	delete (ctab, yes, verify-)
	rename ("tclrt.tab", ctab, field="all")

	printf("\n%1s\n", "TCOLARIT: Done.")

end
