procedure icnt ()

int	ni	= 1	{prompt="Counter to increase"}
int	i1	= 0	{prompt="Counter 1"}
int	i2	= 0	{prompt="Counter 2"}
int	i3	= 0	{prompt="Counter 3"}
int	d1	= 1	{prompt="Increment of counter 1"}
int	d2	= 1	{prompt="Increment of counter 2"}
int	d3	= 1	{prompt="Increment of counter 3"}
int	i1min	= 0	{prompt="Minimum (offset) value of counter 1"}
int	i2min	= 0	{prompt="Minimum (offset) value of counter 2"}
int	i3min	= 0	{prompt="Minimum (offset) value of counter 3"}
int	i1max	= INDEF	{prompt="If i1 exceeds this value, increase i2"}
int	i2max	= INDEF	{prompt="If i2 exceeds this value, increase i3"}
int	i3max	= INDEF	{prompt="If i3 exceeds this value, reset i3"}
bool	ireset	= no	{prompt="Reset all counters to their default (0) ?"}
bool	dreset	= no	{prompt="Reset all increments to their default (1)?"}

# @(#) task icnt                      Author: R.A. Jansen -- Apr 10 2001
# @(#)
# @(#) Simple task to keep track of counters (eg, in nested loops within
# @(#) IRAF CL scripts, or in command line applications).  Per call, one
# @(#) counter may be updated.  Default is to increase  the counter that
# @(#) was updated in the previous call.  If  'ireset' (or 'dreset')  is
# @(#) true, all counters (increments) are reset to their defaults. Also
# @(#) the default counter is reset to 1.  Using  'i1max'  and  'i2max',
# @(#) nested while-loops can be created, with i1 the innermost counter. 
# @(#) If you want to be sure that the counters will be in the specified
# @(#) range and starting from the minimum values, initialize i1, i2, i3
# @(#) to i1min-d1, i2min-d2, and i3min-d3.

begin
	int	nn, ii1, ii2, ii3, dd1, dd2, dd3
	int	mn1, mn2, mn3, mx1, mx2, mx3

#	Initialize variables...
	nn  = ni
	ii1 = i1
	ii2 = i2
	ii3 = i3
	dd1 = d1
	dd2 = d2
	dd3 = d3
	mn1 = i1min
	mn2 = i2min
	mn3 = i3min
	mx1 = i1max
	mx2 = i2max
	mx3 = i3max
	if ( mx1 == 0 ) { mx1 = INDEF }
	if ( mx2 == 0 ) { mx2 = INDEF }
	if ( mx3 == 0 ) { mx3 = INDEF }

#	Update the specified counter...
	if ( nn < 2 || nn > 3 ) { nn = 1 }
	if ( nn == 1 ) {
	   if ( (ii1+dd1) < mx1 ) {
	      ii1 = ii1 + dd1
	   } else {
	      ii1 = mn1
	      ii2 = ii2 + dd2
	   }
	}
	if ( nn == 2 ) {
	   if ( (ii2+dd2) < mx2 ) {
	      ii2 = ii2 + dd2
	   } else {
	      ii2 = mn2
	      ii3 = ii3 + dd3
	   }
	}
	if ( nn == 3 ) {
	   if ( (ii3+dd3) < mx3 ) {
	      ii3 = ii3 + dd3
	   } else {
	      ii3 = mn3
	   }
	}
	if ( ii1 < mn1 ) { ii1 = mn1 }
	if ( ii2 < mn2 ) { ii2 = mn2 }
	if ( ii3 < mn3 ) { ii3 = mn3 }

#	Check whether the action specified was a reset...
	if (ireset) {
	   # reset all counters
	   ni = 1
           i1 = 0
	   i2 = 0
	   i3 = 0
	   ireset = no
	}
	if (dreset) {
	   # reset all increments
	   d1 = 1
	   d2 = 1
	   d3 = 1
	   dreset = no
	}

#	Return updated task parameters...
	ni = nn
	i1 = ii1
	i2 = ii2
	i3 = ii3
	d1 = dd1
	d2 = dd2
	d3 = dd3
	i1min = mn1
	i2min = mn2
	i3min = mn3
	i1max = mx1
	i2max = mx2
	i3max = mx3

end
