procedure rdlist (infile, nline)

string	infile	=""		{prompt="file name"}
int	nline	=1		{prompt="number of line to return"}
string	cline	=""		{prompt="returned line"}
bool	ok	=no		{prompt="was line read succesfully?"}

# @(#) task rdlist                  Author: R.A. Jansen -- April 23 1995
# @(#)
# @(#) Simple task to return the n-th line in a file as a task parameter
# @(#) If 'nline' exceeds the number of lines in 'infile', or is invalid
# @(#) otherwise,  then 'cline' is returned empty ("") and 'ok = no'.
# @(#)
# @(#) Uses rjtools task:  chkimg
# @(#) 
# @(#) Jun 12 2000 -- Added test for existence of 'infile'. RAJ.
# @(#) Jul 31 2003 -- Added 'ok' to signal success or failure. RAJ.

begin
	string	cfil, cstr
	struct	line
	int	nget, iget
	bool	bok

#	Initialize variables ...
	cfil = infile
	nget = nline
	cstr = ""
	bok  = no

#	Check whether the input file exists ...
	chkimg (infile, "access", imtype="file", verbose=yes)
	if (!chkimg.ok) {
	   cline  = ""
	   ok     = no
	   return
	}

#	Try to read to line number 'nline' ...
	list = infile
	iget = 0
	while ( fscan(list,line) != EOF ) {
	   iget += 1
	   if ( iget == nget ) {
              cstr = line
	      bok  = yes
	      break
           }
        }
        list = ""

#	Update task parameters...
	infile	= cfil
	nline	= nget
	cline	= cstr
	ok	= bok

end
