procedure rpbuild (xlo, xhi, ylo, yhi)

int	xlo	=INDEF		{min=1, max=32768, prompt="x_start"}
int	xhi	=INDEF		{min=1, max=32768, prompt="x_end"}
int	ylo	=INDEF		{min=1, max=32768, prompt="y_start"}
int	yhi	=INDEF		{min=1, max=32768, prompt="y_end"}
int	pln	=0		{min=0, max=256, 
				prompt="image plane (multi-extension FITS)"}
string	imrpstr	=""		{prompt="output image region/plane string"}

# @(#) task rpbuild              Author: R.A. Jansen -- December  2 2000
# @(#) 
# @(#) task to construct an image region/plane string  of generic format
# @(#) [pln][xlo:xhi,ylo:yhi],  where the image plane  is optional (=0).
# @(#) The constructed string  is returned as  task parameter 'imrpstr'.
# @(#) Presently, the ranges in x and y are limited to 1...32768 and the
# @(#) maximum number of planes/extensions is set to 256.  Since primary
# @(#) headers (extension 0) in multi-extension FITS files have  no data
# @(#) unit associated with them, and specifying a section following [0]
# @(#) would be meaningless,  'pln = 0'  is taken to denote 'EXTEND = F'
# @(#) corresponding to output format [xlo:xhi,ylo:yhi].

begin
	string	ctmp
	int	x1, x2, y1, y2, ip

#	Initialize variables...
	x1  = xlo
	x2  = xhi
	y1  = ylo
	y2  = yhi
	ip  = pln
	if ( ip == INDEF ) { ip = 0 }

#	Construct region/plane string...
	if ( ip == 0 ) {
	   ctmp = "["
	} else {
	   ctmp = "["//str(ip)//"]["
	}
	if ( x1 == INDEF && x2 == INDEF ) {
	   ctmp = ctmp//"*,"
	} else if ( x1 == INDEF ) {
	   ctmp = ctmp//"1:"//str(x2)//","
	} else if ( x2 == INDEF ) {
	   ctmp = ctmp//str(x1)//":"//str(max(1,x1))//","
	} else {
	   ctmp = ctmp//str(x1)//":"//str(x2)//","
	}
	if ( y1 == INDEF && y2 == INDEF ) {
	   ctmp = ctmp//"*]"
	} else if ( y1 == INDEF ) {
	   ctmp = ctmp//"1:"//str(y2)//"]"
	} else if ( y2 == INDEF ) {
	   ctmp = ctmp//str(y1)//":"//str(max(1,y1))//"]"
	} else {
	   ctmp = ctmp//str(y1)//":"//str(y2)//"]"
	}

#	Update task parameters...
	xlo	= x1
	xhi	= x2
	ylo	= y1
	yhi	= y2
	pln	= ip
	imrpstr = ctmp

end
